﻿namespace ConsoleApp2.Options;

public enum ColumnType
{
    Blob,
    Text,
    UnDefine,
}

public class DataTransformOptions
{
    public Func<DataRecord, string>? DatabaseFilter { get; set; }
    
    /// <summary>
    /// 配置导入数据的特殊列
    /// </summary>
    public Dictionary<string, ColumnType> ColumnTypeConfig { get; set; } = new(); // "table.column" -> type

    public ColumnType GetColumnType(string table, string column)
    {
        return ColumnTypeConfig.GetValueOrDefault($"{table}.{column}", ColumnType.UnDefine);
    }
}